// WARNING - when you modify any of these, make sure to rebuild the entire 
//           project by using the "Execute" --> "Rebuild All" options of the
//           menu before to do a "Execute" --> "Run"

#ifndef _SHT_H_
#define _SHT_H_


#define _HASH_KEY_STRL_     10 
#define _HASH_SIZE_         20 
#define _HASH_SIZE_PRIMER_  23

// Uncomment the line below to have all of our functions display 
// some intermediary information to facilitate debugging 
#define _DEBUG_MODE_



// Map data structure, represents a pair { key, value } inside the hash table
struct map{ 
       char*  key;     // Pair's key, only the first _HASH_KEY_STRL first bytes
                       // are used for hashing 
       char*  value;   // Value is just a regular string
}; 
typedef struct map Map; 


// HashTable data structure, represents the whole hash table except 
// the hashing function
struct hashtable{
       int tablesize; // # of buckets available 
       int nbpairs;   // # of elements stored in the hash table
       int primer;    // Internal Parameter set to _HASH_SIZE_PRIMER_
       int keysize;   // # of bytes used in the key strings for hashing purposes
       Map **buckets; // Dynamically allocated array of pointers on dynamically 
                      // allocated Map data structures. 
}; 
typedef struct hashtable HashTable;



// API of our hash table data type 
int            sht_size( HashTable* pht ); 
int            sht_isempty( HashTable* pht); 
HashTable*     sht_new(); 
void           sht_debug_display();
void           sht_destroy( HashTable* pht); 
int            sht_put( HashTable* pht, char*  k, char* v); 
int            sht_remove ( HashTable* pht, char* k );
char*          sht_get( HashTable* pht, char* k); 
int            hashFunction(char* k);
#endif
