#include <stdio.h> 
#include <stdlib.h>

#include "sht.h"


void test_keys();
void test_hashtables();

int main(){
    printf("Starting testing SHT...\n");
    //test_keys();
    test_hashtables();
    printf("PRESS ENTER...\n"); 
    char tmp = getchar(); 
}


void test_hashtables(){
     HashTable* p = NULL;
     
     p = sht_new(); 
     
     printf("Initial Table \n"); 
     sht_debug_display(p); 
     printf("\n"); 
     
     sht_put(p, "hello", "Bonjour"); 
     sht_put(p, "hi", "Salut");
     sht_put(p, "woot", "Woot");
     sht_put(p, "woot", "Super!!!"); 

     sht_remove(p, "woot"); 
     sht_put(p, "woot", "PlusPlus"); 
     char* value; 
     value = sht_get(p, "woot"); free(value); 
     value = sht_get(p, "hi"); free(value); 
     
     sht_put(p, "whatever", "bah"); 
     sht_remove(p ,"whatever"); 
     
     value = sht_get(p, "whatever"); 
     if(value){ free(value); perror("value not null"); exit(EXIT_FAILURE);}
     
     printf("Resulting Table \n"); 
     sht_debug_display(p); 
     printf("\n"); 
  
     sht_destroy(p); 
     p=NULL;
     
}


char* readKey(); 
void test_keys(){
     char * str; 
    
     while(1){ 
              str = readKey();           
              printf("Key = %s Hash = %d\n", str, hashFunction(str)); 
     }             
 }

char* readKey(){
      char buffer[256]; 
      printf("Enter key "); 
      scanf("%256s", buffer); 
      int n; 
      
      char* key = NULL; 
      key = malloc(sizeof(char) * _HASH_KEY_STRL_); 
      if(!key){ 
              perror("Unable to malloc key"); 
              exit (EXIT_FAILURE); 
      }
              
      for(n=0 ; n < _HASH_KEY_STRL_ ; n++){
           key[n] = '\0'; 
      } 
      
      strncpy(key, buffer, _HASH_KEY_STRL_ -1); 
      
      return key;
}
